﻿using System;
using System.Collections.Generic;
using EPiServer.Common.Attributes.DataTypes;

namespace ExampleProjects.Movie.DataTypes
{
    public class MovieAttributeDataTypeProvider : IAttributeDataTypeProvider
    {
        private static MovieAttributeDataTypeProvider _instance
            = new MovieAttributeDataTypeProvider();

        public static IAttributeDataTypeProvider GetProviderInstance()
        {
            return _instance;
        }

        public IAttributeDataType GetDataTypeInstance(
            Type complexType, List<object> dbValues)
        {
            if (complexType == typeof(Movie))
                return new MovieAttributeDataType(dbValues);

            string errorMessage = string.Format(
                "Request for unsupported type {0}.", complexType);
            throw new NotSupportedException(errorMessage);
        }

        public Type[] SupportedTypes
        {
            get { return new [] { typeof(Movie) }; }
        }
    }
}
